// Jedes geladene Fenster soll dieses Event aufrufen
window.addEventListener("load", ebay_statusbarLoadPage, true); 


// wird in "ebay_statusbarOverlayNavigate.js" (Methode: Navigate_eBay_Produktsuche) gesetzt:
var ebay_statusbarTextToHighlite = ""; 

function ebay_statusbarGetSelectedText() {
try
{
    var focusedWindow = new XPCNativeWrapper(document.commandDispatcher.focusedWindow, 'document', 'getSelection()');
    var searchSelectText = focusedWindow.getSelection.call(focusedWindow);

    if (searchSelectText == "") {
        searchSelectText = window.getSelection();
    }

    searchSelectText = searchSelectText.toString();
    // Leerzeichen entfernen
    searchSelectText = ebay_statusbarTrim(searchSelectText);
    return searchSelectText;
}catch(e) {
  alert(e);
}
}

//------------------------------------------------------------------------------------------------------------------------------------
function ebay_statusbarTrim(string) {
    try {
        var newString  = '';
       var substring  = '';
       beginningFound = false;
       for (var i = 0; i < string.length; i++) {
               if (string.charAt(i) != ' ' && string.charCodeAt(i) != 9) {
                       if (substring != '') {
                               newString += substring;
                               substring = '';
                       }
                       newString += string.charAt(i);
                       if (beginningFound == false) beginningFound = true;
               }
               else if (beginningFound == true) substring += string.charAt(i);
       }
       return newString;
    }catch(e) {
        alert(e);
    }
}
//------------------------------------------------------------------------------------------------------------------------------------

function ebay_statusbarOnPopupContextMenu() {
  var s = ebay_statusbarGetSelectedText();
  // Produktsuche bei eBay nur erlauben, wenn was markiert wurde
  if (s == "") {
    document.getElementById("ebay_statusbarebayselsearch").setAttribute("disabled","true");
} else {
    document.getElementById("ebay_statusbarebayselsearch").setAttribute("disabled","false");
  };

  return true;
};


function ebay_statusbarLoadPage(event)
{
  ebay_statusbarHighlite();
};

function ebay_statusbarHighliteRange(range, node) {
  var startContainer = range.startContainer;
  var startOffset = range.startOffset;
  var endOffset = range.endOffset;
  var docfrag = range.extractContents();
  var before = startContainer.splitText(startOffset);
  var parent = before.parentNode;
  node.appendChild(docfrag);
  parent.insertBefore(node, before);
  return node;
}

function ebay_statusbarHighliteWithElement(baseNode) {
  var body = window._content.document.body;
  if (!body) return;
  
  var count = body.childNodes.length;
  var flag = 0;

  Finder = Components.classes["@mozilla.org/embedcomp/rangefind;1"].createInstance().QueryInterface(Components.interfaces.nsIFind);
  
  searchRange = window._content.document.createRange();
  startPt = window._content.document.createRange();
  endPt = window._content.document.createRange();

  searchRange.setStart(body, 0);
  searchRange.setEnd(body, count);
	
  startPt.setStart(body, 0);
  startPt.setEnd(body, 0);
  endPt.setStart(body, count);
  endPt.setEnd(body, count);
  
  while (retRange = Finder.Find(ebay_statusbarTextToHighlite, searchRange, startPt, endPt)) {
    var nodeSurround = baseNode.cloneNode(true);
    var node = ebay_statusbarHighliteRange(retRange, nodeSurround);
		
    startPt = node.ownerDocument.createRange();
    startPt.setStart(node, node.childNodes.length);
    startPt.setEnd(node, node.childNodes.length);
	flag=flag+1;
  }
};

function ebay_statusbarHighlite() {
  try {
  // nix da -> nix tun
  if (ebay_statusbarTextToHighlite=="") return false;
  
  // erster Durchlauf: CSS einfgen (hellgelber Hintergrund)
  var baseNode = window._content.document.createElement("span");
  baseNode.setAttribute("style", "background-color:#FFFF00");
  ebay_statusbarHighliteWithElement(baseNode);
  
  // zweiter Durchlauf: fett darstellen
  baseNode = window._content.document.createElement("b");
  ebay_statusbarHighliteWithElement(baseNode);
  
  // nicht vergessen die Variable wieder zu leeren
  ebay_statusbarTextToHighlite = "";
}catch(e) {
  alert(e);
}
};